// Created with MonoDevelop
//
//    QuickStep: Acquire, view and identify spectra 
//    Copyright (C) 2024 Hiperscan GmbH Dresden, Germany
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.


using System;
using Hiperscan.PdfLib;
using Hiperscan.Unix;

namespace Hiperscan.ApoIdentCore.Reporting.Protocol.Rating
{
    public class CommonCannabisRating : IDraw
    {
        public bool Draw(PdfArgs args)
        {
            args.Layout.Feed(args.Layout.ParagraphBoundingBox.Height);
            args.Layout.Feed(0.6 * args.ReferenceParagraphFeed);

            args.Layout.SetFont(PdfFontTypes.HELVETICA, args.ReferenceFontSize, PdfColors.Black);

            args.Layout.XPosition = 0;
            string text = Catalog.GetString("Quantitive analysis*:");
            if (args.Layout.AddParagraph(text) == false)
                return false;

            this.DrawPositiveCannabisResult(args);

            args.Layout.XPosition = args.ReferenceTabIndent;
            args.Layout.Feed(args.Layout.ParagraphBoundingBox.Height + args.ReferenceLineDistance + 2);
            args.Layout.SetFont(PdfFontTypes.HELVETICA, 0.65 * args.ReferenceFontSize, PdfColors.Black);

            text = Catalog.GetString("* 95.4% of the measured values fall within the specified interval of 2 sigma. The determined values may deviate from the analysis certificate and do not replace it. The sample is subject to, among other things, natural fluctuations.");

            if (args.Layout.AddParagraph(text) == false)
                return false;

            args.Layout.Feed(args.Layout.ParagraphBoundingBox.Height + args.ReferenceLineDistance);
            return true;
        }

        private bool DrawPositiveCannabisResult(PdfArgs args)
        {
            args.Layout.XPosition = args.ReferenceTabIndent;
            args.Layout.SetFont(PdfFontTypes.HELVETICA, args.ReferenceFontSize, PdfColors.Black);
            string text = Catalog.GetString("THC") + ": ";
            double width = args.Layout.MeasureString(text);
            if (args.Layout.AddParagraph(text) == false)
                return false;

            args.Layout.XPosition += width;
            args.Layout.SetFont(PdfFontTypes.HELVETICA_BOLD, args.ReferenceFontSize, PdfColors.Black);
            text = args.Info.CannabisResult.GetTHCResultInPercent();
            width = args.Layout.MeasureString(text);
            if (args.Layout.AddParagraph(text) == false)
                return false;

            args.Layout.XPosition += width;
            args.Layout.SetFont(PdfFontTypes.HELVETICA, args.ReferenceFontSize, PdfColors.Black);
            text = " " + args.Info.CannabisResult.GetTHCTolerance() + " ";
            width = args.Layout.MeasureString(text);
            if (args.Layout.AddParagraph(text) == false)
                return false;

            args.Layout.XPosition += width;
            args.Layout.SetFont(PdfFontTypes.HELVETICA, args.ReferenceFontSize * 0.8, PdfColors.Black);
            text = args.Info.CannabisResult.GetTHCSigma(true);
            width = args.Layout.MeasureString(text);
            if (args.Layout.AddParagraph(text) == false)
                return false;

            args.Layout.XPosition += width;
            args.Layout.SetFont(PdfFontTypes.HELVETICA, args.ReferenceFontSize, PdfColors.Black);
            text = ", " + Catalog.GetString("CBD") + ": ";
            width = args.Layout.MeasureString(text);
            if (args.Layout.AddParagraph(text) == false)
                return false;

            args.Layout.XPosition += width;
            args.Layout.SetFont(PdfFontTypes.HELVETICA_BOLD, args.ReferenceFontSize, PdfColors.Black);
            text = args.Info.CannabisResult.GetCBDResultInPercent();
            width = args.Layout.MeasureString(text);
            if (args.Layout.AddParagraph(text) == false)
                return false;

            args.Layout.XPosition += width;
            args.Layout.SetFont(PdfFontTypes.HELVETICA, args.ReferenceFontSize, PdfColors.Black);
            text = " " + args.Info.CannabisResult.GetCBDTolerance() + " ";
            width = args.Layout.MeasureString(text);
            if (args.Layout.AddParagraph(text) == false)
                return false;

            args.Layout.XPosition += width;
            args.Layout.SetFont(PdfFontTypes.HELVETICA, args.ReferenceFontSize * 0.8, PdfColors.Black);
            text = args.Info.CannabisResult.GetCBDSigma(true);
            width = args.Layout.MeasureString(text);
            if (args.Layout.AddParagraph(text) == false)
                return false;

            return true;
        }
    }
}
